package com.jesusrojo.miphoto.model.almacen;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.net.Uri;

import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.model.pojo.User;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.utils.UtilsFile;

import java.util.ArrayList;
import java.util.List;

public class UsersSQLite extends SQLiteOpenHelper  {

    private final String TAG = getClass().getSimpleName();

    private Context mContext;

    private static final String TABLE_NAME = "table_register";
    private  String mUserTableName;
    private  String mTableFullName;

    private static final String _ID= "_id";
    private static final String NAME= "name";
    private static final String PASSWORD = "password";
    private static final String EMAIL = "email";
    private static final String TIME = "time";

    public UsersSQLite(Context context) {
        super(context, TABLE_NAME, null, 1);
        this.mContext = context;
      //  this.mUserTableName = userName;
      //  mTableFullName = TABLE_NAME + mUserTableName;
        mTableFullName = TABLE_NAME;
    }
    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL("CREATE TABLE " + mTableFullName + " (" +
                _ID + " INTEGER PRIMARY KEY AUTOINCREMENT" +
                ", " + NAME + " TEXT" +
                ", " + PASSWORD + " TEXT" +
                ", " + EMAIL + " TEXT" +
                ", " + TIME + " LONG)");
    }
    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        Utils.showLog(TAG, "onUpgrade(");
        // En caso de una nueva versión habría que actualizar las tablas
    }
    public String registerUser(Context context, User user) {
        int _id = -1;
        String _name = null;
        String _password = null;
        String _email = null;
        SQLiteDatabase bd = getReadableDatabase();

        Cursor c = bd.rawQuery("SELECT * " +
               "FROM " + mTableFullName + " " +
               "WHERE " + NAME + "= '" + user.getName() + "'"
               , null);
        if(c.moveToNext()) {
            _id = c.getInt(0);//_id
            _name = c.getString(1);//name
            _password = c.getString(2);//password
            _email = c.getString(3);//email
        }
        if(_name != null && _name.equals( user.getName() )){
            return Constants.ERROR_ALREADY_USER;
        }
        c = bd.rawQuery("SELECT * " +
                "FROM " + mTableFullName + " " +
                "WHERE " + EMAIL + "= '" + user.getEmail() + "' "
                , null);
        if(c.moveToNext()) {
            _id = c.getInt(0);//_id
            _name = c.getString(1);//name
            _password = c.getString(2);//password
            _email = c.getString(3);//email
        }
       // c.close();

       if(_email != null && _email.equals( user.getEmail() )){
           return Constants.ERROR_ALREADY_MAIL;

       }
        Utils.showLog(TAG, "name " + _name + " pass " + _password);

        //cerramos el cursor
       c.close();
       bd.execSQL("INSERT INTO "+mTableFullName+" VALUES ( null"
                   + ", '" + user.getName() + "' "
                   + ", '" + user.getPassword() + "' "
                   + ", '" + user.getEmail() + "' "
                   + ", " + user.getTime() + ")");
        bd.close();
        return Constants.SUCCESS;
    }
    public String insertUser(Context c, User user) {
        SQLiteDatabase db = getWritableDatabase();
        db.execSQL("INSERT INTO " + mTableFullName + " VALUES ( null"
                + ", '" + user.getName() + "' "
                + ", '" + user.getPassword() + "' "
                + ", '" + user.getEmail() + "' "
                + ", " + user.getTime() + ")");
        db.close();

        return Constants.SUCCESS_SAVED;
    }
    public String checkLogin(String name, String password) {
        int _id = -1;
        String _name = null;
        String _password = null;
        SQLiteDatabase bd = getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * " +
                "FROM " + mTableFullName + " " +
                "WHERE " + NAME + "= '" + name + "' "+
                "AND " + PASSWORD + "= '" + password + "'"
                , null);
        if(c.moveToNext()) {
            _id = c.getInt(0);//_id
            _name = c.getString(1);//name
            _password = c.getString(2);//password
        }
        c.close();
        bd.close();

        if(name.equals(_name) && password.equals(_password)){
            return Constants.SUCCESS;
        } else {
            return Constants.ERROR_NOT_LOGIN;
        }
    }

    public String[] sendNewPassword(String mail) {
        Utils.showLog(TAG, "sendNewPassword");
        int _id = -1;
        String _name = null;
        String _password = null;
        String _email = null;
        String[] args = new String[2];
        SQLiteDatabase bd = getReadableDatabase();
        Cursor c = bd.rawQuery("SELECT * " +
                "FROM " + mTableFullName + " " +
                "WHERE " + EMAIL + "= '" + mail + "'"
                , null);
        if(c.moveToNext()) {
            _id = c.getInt(0);//_id
            _name = c.getString(1);//name
            _password = c.getString(2);//password
            _email = c.getString(3);//email

        }
        c.close();
        bd.close();
        if(_email != null && _email.equals( mail )) {
            args[0] = _name;
            args[1] = _password;

            return args;

        } else {
            return null;
        }
    }

    public List<User> getListUsers() {
        SQLiteDatabase db = getReadableDatabase();
        String[] CAMPOS = {_ID,  NAME, PASSWORD, EMAIL, TIME};
        Cursor cursor=db.query(mTableFullName, CAMPOS, null, null,
                null, null, "time DESC", null);
        List<User> list = new ArrayList<>();
        while (cursor.moveToNext()){
            list.add(new User(
                    cursor.getInt(0),
                    cursor.getString(1),
                    cursor.getString(2),
                    cursor.getString(3),
                    cursor.getLong(4)
            ));
        }
        cursor.close();
        db.close();
        return list;
    }
    public String updateUser(Context context, String[] pojoForUpdate) {
        String[] dataForUpdate = pojoForUpdate;
        SQLiteDatabase db = getWritableDatabase();
        db.execSQL("UPDATE " + mTableFullName + " "
                        + "SET " + EMAIL + "='" + "file://" + dataForUpdate[1] + "' "
                        + "WHERE " + PASSWORD + "='" + dataForUpdate[0] + "'"
        );
        db.close();
        return Constants.SUCCESS_UPDATED;
    }


    public String deleteUsersByPath(String[] selectArg) {
        SQLiteDatabase db = getWritableDatabase();

        for(int i= 0; i < selectArg.length; i++) {

            if (selectArg[i] != null) {
                db.execSQL("DELETE FROM "+mTableFullName+" " +
                        "WHERE "+PASSWORD+"='" + selectArg[i] + "'");
            }
        }
        db.close();
        return  Constants.SUCCESS_DELETED;
    }

}
