package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.app.NotificationManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.support.v4.app.NotificationCompat;
import android.support.v4.content.LocalBroadcastManager;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.PhotosListActivity;


public class DeletePojoTask extends AsyncTask<String[], Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private Mediator mMediator;
    private final ITaskCallback myInterface;

    public DeletePojoTask(Activity a, Context c, ITaskCallback listener) {
        this.mContext = c;
        this.mActivity = a;
        this.myInterface = listener;
        mMediator = new Mediator(mContext);
    }
	@Override
	protected String doInBackground(String[]... arg) {
		if (!isCancelled()) {
            return  mMediator.deletePojo(mContext, arg[0]);
        } else {
            return Constants.ERROR;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS_DELETED) ) {
          //  Utils.showToastCustom( mContext,mContext.getResources().getString(R.string.success_deleted_sql),"verde", 0);
            myInterface.onFinishDeletePojoTask(result);
           // mActivity.startActivity(new Intent(mContext, PhotosListActivity.class));
           // mActivity.finish();
        } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.error_not_deleted), "rojo", 0);
        }
    }
}
