package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.os.AsyncTask;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.PhotosListActivity;

import java.util.List;


public class GetListTask extends AsyncTask<Void, Void, List<Photo>> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private Mediator mMediator;
    private ProgressDialog mProgressDialog;

    private final ITaskCallback myInterface;

	public GetListTask(Activity a, Context c, ITaskCallback listener, ProgressDialog p) {
		this.mContext = c;
        this.mActivity = a;
        this.myInterface = listener;
        this.mProgressDialog = p;
        mMediator = new Mediator(mContext);
    }

    @Override
	protected List<Photo> doInBackground(Void... arg) {
		if (!isCancelled()) {
            PhotosListActivity.isTaskWorking = true;

            return mMediator.getListPhotos(mContext);
        } else {
            return null;
        }
	}
	@Override
	protected void onPostExecute(List<Photo> result) {
		super.onPostExecute(result);
        PhotosListActivity.isTaskWorking = false;
        if (result != null) {
            myInterface.onFinishGetListTask(result);
        } else {
            Utils.showToastCustom(mContext,mActivity.getResources().getString(R.string.error_getting_list), "rojo", 0);
        }
    }
}
