package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnCancelListener;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.LoginActivity;
import com.jesusrojo.miphoto.view.RegisterActivity;

public class RegisterTask extends AsyncTask<String, Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private static SharedPreferences mSharedPref;
    private SharedPreferences.Editor mEditor;
    private Mediator mMediator;

	private ProgressDialog progressDialog;

    private String mName;
	private String mPassword;
	private String mMail;
    private String mFromWhere;

    public IRegisterTaskCallback listener;
    public interface IRegisterTaskCallback {
        void onFinishMyRegisterTask(String result);
    }
    ////
	public RegisterTask(Activity a, Context c, ProgressDialog p,
                        IRegisterTaskCallback listener) {
        this.mActivity = a;
        this.mContext = c;
        this.progressDialog = p;
        this.listener = listener;
        this.mMediator = new Mediator( mContext );
        mSharedPref = mActivity.getSharedPreferences(Constants.PREFERENCES_DEFAULT, Context.MODE_PRIVATE);
    }

    public void empezarTask(String name, String password,String mail, String fromWhere){
        mName = name;
        mPassword = password;
        mMail = mail;
        if(fromWhere.equals("device")){
            mFromWhere = "device";
        }
        if(fromWhere.equals("cloud")){
            mFromWhere = "cloud";
        }
        this.execute(name,password, mail);
    }
	@Override
	protected void onPreExecute() {
		super.onPreExecute();
		try {
            progressDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            if(mFromWhere.equals("device")){
                progressDialog.setMessage(mActivity.getResources()
                        .getString(R.string.registrando_usuario));

            }
            if(mFromWhere.equals("cloud")){
                progressDialog.setMessage(mActivity.getResources()
                        .getString(R.string.connecting_with_internet));
            }
            progressDialog.setCancelable(true);
            progressDialog.show();
			progressDialog.setOnCancelListener(new OnCancelListener() {
				@Override
				public void onCancel(DialogInterface dialog) {
					cancel(true);
				}
			});
		} catch (Exception e) {
			Utils.showLogError(TAG, "Error, e: " + e);
		}
	}
	@Override
	protected String doInBackground(String... arg) {
		if (!isCancelled()) {
			RegisterActivity.isTaskWorking = true;
			return mMediator.register(arg[0], arg[1], arg[2], mFromWhere);
		}
		return null;
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);

        if(progressDialog.isShowing()) {
            progressDialog.dismiss();
        }
        LoginActivity.isTaskWorking = false;
        listener.onFinishMyRegisterTask(result);
	}
}
