package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.app.NotificationManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.support.v4.app.NotificationCompat;
import android.support.v4.content.LocalBroadcastManager;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;


public class SavePojoNubeTask extends AsyncTask<Photo, Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private Mediator mMediator;
    private ITaskCallback mListener;
    private Photo mPhoto;


	public SavePojoNubeTask(Activity a, Context c, ITaskCallback listener) {
		this.mContext = c;
        this.mActivity = a;
        mListener = listener;
        mMediator = new Mediator(mContext);

    }
	@Override
	protected String doInBackground(Photo... arg) {
        mPhoto = arg[0];
		if (!isCancelled()) {
            return  mMediator.savePojoNube(mContext, arg[0]);
        } else {
            return Constants.ERROR;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS)) {
          //  Utils.showToastCustom(mContext,mContext.getResources().getString(R.string.success_saved_in_mysql), "verde", 0);
            mListener.onFinishSavePojoNubeTask(result, mPhoto);
        } else {
            Utils.showToastCustom(mContext, result, "rojo", 0);
        }
    }
}
