package com.jesusrojo.miphoto.presenter;


import android.app.Activity;

import android.content.Context;

import android.content.Intent;
import android.os.AsyncTask;


import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.PhotosListActivity;


public class SavePojoTask extends AsyncTask<Photo, Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;

    private final ITaskCallback myInterface;
    private Mediator mMediator;

	public SavePojoTask(Activity a, Context c, ITaskCallback listener) {
		this.mContext = c;
        this.mActivity = a;
        this.myInterface = listener;
        mMediator = new Mediator(mContext);
    }
	@Override
	protected String doInBackground(Photo... arg) {
		if (!isCancelled()) {
            return  mMediator.savePhoto(mContext, arg[0]);
        } else {
            return Constants.ERROR_NOT_SAVED;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS_SAVED)) {
          //  Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.success_saved_in_sqlite), "verde", 0);
            //despues de salvar  el pojo, volvemos a la lista
            mActivity.startActivity(new Intent(mContext, PhotosListActivity.class));
            mActivity.finish();
        } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.error_not_saved_in_sqlite), "rojo", 0);
        }
    }
}
