package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.app.NotificationManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.support.v4.app.NotificationCompat;
import android.support.v4.content.LocalBroadcastManager;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;


public class UpdatePathFilterTask extends AsyncTask<String[], Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private final ITaskCallback myInterface;
    private Mediator mMediator;

    public UpdatePathFilterTask(Activity a, Context c, ITaskCallback listener) {
		this.mContext = c;
        this.mActivity = a;
        this.myInterface = listener;
        mMediator = new Mediator(mContext);
    }
	@Override
	protected String doInBackground(String[]... arg) {
        if (!isCancelled()) {
            return  mMediator.updatePathFilteredPhoto(mContext, arg[0]);
        } else {
            return Constants.ERROR_NOT_UPDATED;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS_UPDATED)) {
           // Utils.showToastCustom(mContext, R.string.success_saved, "verde", 0);
            myInterface.onFinishUpdatePathFilterTask(result);
         } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.error_not_saved), "rojo", 0);
        }
    }


}
