package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.PhotosListActivity;


public class UpdatePhotoTask extends AsyncTask<Photo, Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;

    private Mediator mMediator;


	public UpdatePhotoTask(Activity a, Context c) {
		this.mContext = c;
        this.mActivity = a;

        mMediator = new Mediator(mContext);

    }
	@Override
	protected String doInBackground(Photo... arg) {
        if (!isCancelled()) {
            return  mMediator.updatePhoto(mContext, arg[0]);
        } else {
            return Constants.ERROR_NOT_UPDATED;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS_UPDATED )) {
          //  Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.success_saved), "verde", 0);

            //despues de salvar  el pojo, volvemos a la lista
            mActivity.startActivity(new Intent(mContext, PhotosListActivity.class));
            mActivity.finish();

        } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.error_not_saved), "rojo", 0);
        }
    }

}
