package com.jesusrojo.miphoto.presenter;


import android.app.Activity;
import android.content.Context;
import android.os.AsyncTask;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.Mediator;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;


public class UpdateStatusTask extends AsyncTask<String[], Void, String> {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private final ITaskCallback myInterface;
    private Mediator mMediator;

    public UpdateStatusTask(Activity a, Context c, ITaskCallback listener) {
		this.mContext = c;
        this.mActivity = a;
        this.myInterface = listener;
        mMediator = new Mediator(mContext);
    }
	@Override
	protected String doInBackground(String[]... arg) {
        if (!isCancelled()) {
            return  mMediator.updateStatus(mContext, arg[0]);
        } else {
            return Constants.ERROR_NOT_UPDATED;
        }
	}
	@Override
	protected void onPostExecute(String result) {
		super.onPostExecute(result);
        if (result.equals(Constants.SUCCESS_UPDATED)) {
           // Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.success_update_status), "verde", 0);
        } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString(R.string.error_not_update_status), "rojo", 0);
        }
    }
}
