package com.jesusrojo.miphoto.presenter.broadcast;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.support.v4.app.NotificationCompat;

import java.text.DateFormat;
import java.util.Date;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.MainActivity;
import com.jesusrojo.miphoto.view.PhotosListActivity;

public class NotificationA_BroadcastReceiver extends BroadcastReceiver {

    private final String TAG = getClass().getSimpleName();
    private static final int ID_NOTIFICACION_CREAR = 1;

    @Override
    public void onReceive(Context context, Intent intent) {

    //INTENT for the activity to open on click
    final Intent mIntent =
            new Intent(context, MainActivity.class).putExtra("path", "");
    final PendingIntent mPendingIntent =
            PendingIntent.getActivity(context,
                    0, mIntent, PendingIntent.FLAG_UPDATE_CURRENT);

    //NOTIFICTION
    NotificationManager mNotificationManager = (NotificationManager)
            context.getSystemService(Context.NOTIFICATION_SERVICE);

    if (  Build.VERSION.SDK_INT < 11 ) {
        //NotificationCompact.Builder pertenece a la lib compatibilidadd v4
        NotificationCompat.Builder mBuilderCompat =
                new NotificationCompat.Builder(context)
                        // .setProgress(0, 0, true)
                        .setContentTitle(context.getString(R.string.app_name))
                        .setSmallIcon(R.mipmap.ic_launcher)
                        .setContentText(context.getString(R.string.time_for_photo))
                        .setWhen(System.currentTimeMillis() + 1000 * 60 * 60)
                        .setContentInfo(context.getString(R.string.more_info))
                        .setTicker(context.getString(R.string.take_another_photo))
                        .setSound(Uri.parse("android.resource://" + context.getPackageName() + "/" +
                                +R.raw.sound_camara1))
                        .setLights(Color.RED, 3000, 1000);//end mBuilderCompat

        mBuilderCompat.setContentIntent(mPendingIntent);
        mNotificationManager.notify(ID_NOTIFICACION_CREAR,mBuilderCompat.build());
    } else {    //API + 11
        Notification.Builder notificationBuilder =
                new Notification.Builder(context)
                        .setContentTitle(context.getString(R.string.app_name))
                        .setContentText(context.getString(R.string.time_for_photo))
                        .setSmallIcon(R.mipmap.ic_launcher)
                        .setAutoCancel(true)
                        .setSound(Uri.parse("android.resource://" + context.getPackageName() + "/" +
                                +R.raw.sound_camara1))
                        .setContentIntent(mPendingIntent);
        mNotificationManager.notify(1,notificationBuilder.build());
    }
    Utils.showLog(TAG,"Notification at: " + DateFormat.getDateTimeInstance().format(new Date()));
    }//onReceive
}
