package com.jesusrojo.miphoto.presenter.broadcast;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.support.v4.app.NotificationCompat;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.MainActivity;
import com.jesusrojo.miphoto.view.PhotosListActivity;

import java.text.DateFormat;
import java.util.Date;

public class NotificationRA_BroadcastReceiver extends BroadcastReceiver {

    private final String TAG = getClass().getSimpleName();
    private static final int ID_NOTIFICACION_CREAR = 1;

    @Override
    public void onReceive(Context context, Intent intent) {

        final Intent mIntent =
                new Intent(context, MainActivity.class).putExtra("path", "");
        final PendingIntent mPendingIntent =
                PendingIntent.getActivity(context,
                        0, mIntent, PendingIntent.FLAG_UPDATE_CURRENT);

        NotificationManager mNotificationManager = (NotificationManager)
                context.getSystemService(Context.NOTIFICATION_SERVICE); 

        if (  Build.VERSION.SDK_INT < 11 ) {
            //NotificationCompact.Builder pertenece a la lib compatibilidadd v4
            NotificationCompat.Builder mBuilderCompat =
                    new NotificationCompat.Builder(context)
                    // .setProgress(0, 0, true)
                    .setContentTitle(context.getString(R.string.app_name))
                    .setSmallIcon(R.mipmap.ic_launcher)
                    .setContentText("-Time for a Photo")
                  //  .setLargeIcon(BitmapFactory.decodeResource(
                   //         context.getResources(), android.R.drawable.ic_media_play))
                    .setWhen(System.currentTimeMillis() + 1000 * 60 * 60)
                    .setContentInfo("more info")
                    .setTicker("Make another photo")
                    .setDefaults(Notification.DEFAULT_SOUND)
                            .setSound(Uri.parse("android.resource://" + context.getPackageName() + "/" +
                                    +R.raw.sound_camara1))
                    .setDefaults(Notification.DEFAULT_VIBRATE)
                            //mi vibracion
                            //.setVibrate(new long[] {0, 100, 200, 300})
                            // .setVibrate(new int[] {0, 100, 200, 300})

                            //.setDefaults(Notification.DEFAULT_LIGHTS)
                            //mis  luces
                    .setLights(Color.RED, 3000, 1000)
            ;//end mBuilderCompat

            mBuilderCompat.setContentIntent(mPendingIntent);
            mNotificationManager.notify(ID_NOTIFICACION_CREAR,mBuilderCompat.build());
        } else {    //API + 11
            Notification.Builder notificationBuilder =
                    new Notification.Builder(context)
                    .setContentTitle(context.getString(R.string.app_name))
                    .setContentText("+Time for a Photo")
                    .setSmallIcon(R.mipmap.ic_launcher)
                    .setAutoCancel(true)
                   .setSound(Uri.parse("android.resource://" + context.getPackageName() + "/" +
                                    +R.raw.sound_camara1))
                    .setContentIntent(mPendingIntent);
            mNotificationManager.notify(1,notificationBuilder.build());
        }
        
        Utils.showLog(TAG,"Notification at: " + DateFormat.getDateTimeInstance().format(new Date()));
    }
    //
}
