package com.jesusrojo.miphoto.utils;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.util.Log;
import android.view.Gravity;
import android.view.inputmethod.InputMethodManager;
import android.widget.TextView;
import android.widget.Toast;


import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.pojo.Photo;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Utils {

    public static final String TAG = Utils.class.getSimpleName();

    //KEYBOARD
    public static void hideSoftKeyboard(Activity activity) {
        try  {
            InputMethodManager inputMethodManager = (InputMethodManager)
                    activity.getSystemService(Activity.INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(
                    activity.getCurrentFocus().getWindowToken(), 0);
        } catch (Exception e) {
            Utils.showLogError(TAG, "Erro hide keyboardr e " + e);
        }
    }

    //TIME
    public static String millisToHuman(long millis) {
        return  new SimpleDateFormat("yyyy/MM/dd_HH:mm:ss").format(millis);
    }
    public static String getDiaYHora() {
        return  new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
    }
    public static void sleepMiliSeconds(int delay) {
        try {
            Thread.sleep(delay);
            showLog(TAG, "sleeping: " + delay);
        } catch (InterruptedException e) {
            showLogError(TAG, "Error sleeping e: " + e);
        }
    }
    //DEBUG
    public static final Boolean DEBUG = true;
    public static void showLog(String tag, String message) {
        if (DEBUG) {
            if (message != null) {
                Log.d(tag, "==" + message);
            } else {
                Log.d(tag, "<NULL VALUE>");
            }
        }
    }
    //DEBUG ERROR
    public static final Boolean DEBUG_ERROR= true;
    public static void showLogError(String tag, String message) {
        if (DEBUG_ERROR) {
            if (message != null) {
                //red
                Log.e(tag, "==ERROR: " + message);
                //and normal
                showLog(tag, "ERROR: " + message );
            } else {
                Log.e(tag, "<NULL VALUE>");
            }
        }
    }
    //TOAST
    public static final Boolean TOAST = true;
    public static void showToast(Context context,String message) {
        if ( TOAST ) {
            Toast.makeText(context, message, Toast.LENGTH_SHORT).show();
        }else{
            //NO TOAST
        }
    }
    public static void showToastLong(Context context,String message) {
        if ( TOAST ) {
            Toast.makeText(context, message, Toast.LENGTH_LONG).show();
        }else{
            //NO TOAST
        }
    }
    public static void showToastCustom(Context context,
                                          String message,
                                          String color,
                                          int imagen) {
        if ( TOAST ) {
            Toast toast = Toast.makeText(context, message, Toast.LENGTH_SHORT);
            toast.setGravity(Gravity.CENTER_VERTICAL, 0, 0);
            toast.setDuration(Toast.LENGTH_SHORT);
            TextView textView = (TextView) toast.getView().findViewById(android.R.id.message);
            textView.setTextColor(Color.BLACK);
            textView.setTextSize(20);
            textView.setPadding(10,10,10,10);
            if (imagen != 0) {

              //  putImageSeleted(context, imagen, textView);
            }
            if (imagen == 1){
                //tick verde
            }
            if (color != null && !color.equals("")) {
                if (color.equals("rojo")) {
                    textView.setBackgroundColor(Color.RED);

                    putImageError(context,imagen,textView);

                } else if (color.equals("verde")) {
                    textView.setBackgroundColor(Color.GREEN);
                } else {
                    textView.setBackgroundColor(Color.YELLOW);
                }
            } else {
                textView.setBackgroundColor(Color.YELLOW);
            }
            toast.show();
        } else {
            //NO TOAST
        }
    }

    private static void putImageError(Context context, int imagen, TextView textView) {

        if (  Build.VERSION.SDK_INT < 22 ) {
            textView.setCompoundDrawablesWithIntrinsicBounds(
                  //  context.getResources().getDrawable(imagen),
                    context.getResources().getDrawable(R.drawable.error),
                    null, null, null);
        } else {
            textView.setCompoundDrawablesWithIntrinsicBounds(
                   // context.getResources().getDrawable(imagen,context.getTheme()),
                    context.getResources().getDrawable(R.drawable.error,
                            context.getTheme()),null, null, null);
            // context.getResources().getDrawable(imagen,null),
        }
    }
    private static void putImageSuccess(Context context, int imagen, TextView textView) {

        if (  Build.VERSION.SDK_INT < 22 ) {
            textView.setCompoundDrawablesWithIntrinsicBounds(
                    //  context.getResources().getDrawable(imagen),
                    context.getResources().getDrawable(R.drawable.success),
                     null, null, null);
        } else {
            textView.setCompoundDrawablesWithIntrinsicBounds(
                  //  context.getResources().getDrawable(imagen,context.getTheme()),
                    context.getResources().getDrawable(R.drawable.success,context.getTheme()),
                    null, null, null);
            // context.getResources().getDrawable(imagen,null),
        }
    }
    /*
    *******************************

     Utils.showToastCustom(mActivity,
     mActivity.getResources().getString(R.string.error_not_deleted), "rojo", 0);

     Utils.showToastCustom(mActivity,
     mContext.getResources().getString(R.string.error_not_deleted), "verde", 0);

     Utils.showToastCustom(mContext,
     mContext.getResources().getString(R.string.error_not_deleted), "rojo", 0);

     Utils.showToastCustom(mContext,
     mActivity.getResources().getString(R.string.error_not_deleted), "verde", 0);
     ******************************/
}
