package com.jesusrojo.miphoto.view;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ToggleButton;

import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.analytics.GoogleAnalytics;
import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;

public class DatosConexionActivity extends AppCompatActivity {

    private final String TAG = getClass().getSimpleName();
    private Activity activity;
    private Context mContext;
    private SharedPreferences mSharedPref;
    private SharedPreferences.Editor editor;
    private boolean isMyHostig;

    //datos register
    private EditText ET_hosting, ET_register, ET_login,
            ET_upload, ET_upload_binary, ET_get_list, ET_send_new_password;
    private CheckBox checkBox_save;
    private String hosting, register, login, upload, upload_binary, get_list, send_new_password;
    private ToggleButton toggleButton;
    private AdView adView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.datos_conexion_layout);
        this.activity = this;
        this.mContext = getApplicationContext();
        mSharedPref = getSharedPreferences(Constants.PREFERENCES_DEFAULT, Context.MODE_PRIVATE);

        adView = (AdView)findViewById(R.id.adView);
        AdRequest adRequest = new AdRequest.Builder()
                .build();
        adView.loadAd(adRequest);

        getAllViews();

        getUrlDataFromPreferences();

        if(hosting.equals(getResources().getString(R.string.hosting_url))
                || hosting.equals("")) {
            putMyHostingInET();
        } else {
            isMyHostig = false;
            fillEditTextWithUrl();
           // toggleButton.setChecked(false);
            setCheckBoxTicked();
        }
        //TOGGLE
        toggleButton.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    putMyHostingInET();
                } else {
                    Utils.showLog(TAG, "toogle off");
                    hideMyHostingFromET();
                }
            }
        });
        //CHECK BOX
        checkBox_save.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    if(isMyHostig){
                        putMyHostingInET();
                    } else {
                        getUrlDataFromEditText();
                        setUrlDataInPreferences();
                        //toast what we are going to save
                        Utils.showToast(mContext, getResources().getString(R.string.saved)
                                        + ",  " + hosting );
                        toggleButton.setChecked(false);
                        setCheckBoxTicked();
                        finish();
                    }
                } else {
                    //is not checked
                    getUrlDataFromPreferences();
                    //toast what we are going to delete
                    Utils.showToast(mContext, getResources().getString(R.string.deleted)
                                    + ",  " + hosting);
                    //delete and set null everything
                    clearEditText();
                    clearUrlDataFromPreferences();
                    toggleButton.setChecked(false);
                    setCheckBoxUnTicked();
                }
            }
        });
        //end checkBox


    }//onCreate

    private void fillEditTextWithUrl() {
        ET_hosting.setText(hosting);
        ET_register.setText(register);
        ET_login.setText(login);
        ET_upload.setText(upload);
        ET_upload_binary.setText(upload_binary);
        ET_get_list.setText(get_list);
        ET_send_new_password.setText(send_new_password);
    }
    private void getAllViews() {
        ET_hosting = (EditText) findViewById(R.id.ET_hosting);
        ET_register = (EditText) findViewById(R.id.ET_register);
        ET_login = (EditText) findViewById(R.id.ET_login);
        ET_upload = (EditText) findViewById(R.id.ET_upload);
        ET_upload_binary = (EditText) findViewById(R.id.ET_upload_binary);
        ET_get_list = (EditText) findViewById(R.id.ET_get_list);
        ET_send_new_password = (EditText) findViewById(R.id.ET_send_new_password);
        toggleButton= (ToggleButton) findViewById(R.id.toggleButton);
        checkBox_save =(CheckBox) findViewById(R.id.checkBox_save);
    }

    private void getUrlDataFromEditText() {
        hosting = ET_hosting.getText().toString();
        register = ET_register.getText().toString();
        login = ET_login.getText().toString();
        upload = ET_upload.getText().toString();
        upload_binary = ET_upload_binary.getText().toString();
        get_list = ET_get_list.getText().toString();
        send_new_password = ET_get_list.getText().toString();
    }
    private void clearEditText() {
        ET_hosting.setText("");
        ET_register.setText("");
        ET_login.setText("");
        ET_upload.setText("");
        ET_upload_binary.setText("");
        ET_get_list.setText("");
        ET_send_new_password.setText("");
    }


    public void putMyHostingInET() {
        isMyHostig = true;

        hosting =getResources().getString(R.string.hosting_url);
        register = getResources().getString(R.string.register_php);
        login = getResources().getString(R.string.login_php);
        upload = getResources().getString(R.string.upload_php);
        upload_binary =  getResources().getString(R.string.upload_binary_php);
        get_list = getResources().getString(R.string.get_list_php);
        send_new_password = getResources().getString(R.string.send_new_password_php);

        setUrlDataInPreferences();

        fillEditTextWithUrl();

        toggleButton.setChecked(true);
        setCheckBoxTicked();
        //toast what we are going save
        Utils.showToast(mContext, getResources().getString(R.string.saved)+ ", " + hosting );
    }
    public void hideMyHostingFromET() {
        isMyHostig = false;
        clearEditText();
        toggleButton.setChecked(false);
        setCheckBoxUnTicked();
        clearUrlDataFromPreferences();
    }

    private void getUrlDataFromPreferences() {
        hosting = mSharedPref.getString("hosting", "");
        register = mSharedPref.getString("register", "");
        login = mSharedPref.getString("login", "");
        upload = mSharedPref.getString("upload", "");
        upload_binary = mSharedPref.getString("upload_binary", "");
        get_list = mSharedPref.getString("get_list", "");
        send_new_password = mSharedPref.getString("send_new_password", "");
    }
    private void setUrlDataInPreferences() {
        editor = mSharedPref.edit();
        editor.putString("hosting", hosting);
        editor.putString("register", register);
        editor.putString("login", login);
        editor.putString("upload", upload);
        editor.putString("upload_binary", upload_binary);
        editor.putString("get_list", get_list);
        editor.putString("send_new_password", send_new_password);
        editor.apply();
    }
    private void clearUrlDataFromPreferences() {
        editor = mSharedPref.edit();
        editor.putString("hosting", "");
        editor.putString("register", "");
        editor.putString("login", "");
        editor.putString("upload", "");
        editor.putString("upload_binary", "");
        editor.putString("get_list", "");
        editor.putString("send_new_password", "");
        editor.apply();
    }

    public static boolean checkDatosConexion(SharedPreferences sharedPref) {
        String hosting = sharedPref.getString("hosting", "");
        String register = sharedPref.getString("register", "");
        String login = sharedPref.getString("login", "");
        String upload = sharedPref.getString("upload", "");
        String upload_binary = sharedPref.getString("upload_binary", "");
        String get_list = sharedPref.getString("get_list", "");
        String send_new_password = sharedPref.getString("send_new_password", "");
        if(TextUtils.isEmpty(hosting)
                || TextUtils.isEmpty(register)
                || TextUtils.isEmpty(login)
                || TextUtils.isEmpty(upload)
                || TextUtils.isEmpty(upload_binary)
                || TextUtils.isEmpty(get_list)
                || TextUtils.isEmpty(send_new_password)
                ) {
           // Utils.showLog(TAG, "checkDatosConexion: " + false);
            return false;
        } else {
          //  Utils.showLog(TAG, "checkDatosConexion: " + true);
            return true;
        }
    }
    private void setCheckBoxTicked() {
        checkBox_save.setChecked(true);
        checkBox_save.setText(getResources().getString(R.string.saved));
        checkBox_save.setBackgroundColor(Color.GREEN);
    }
    private void setCheckBoxUnTicked() {
        checkBox_save.setChecked(false);
        checkBox_save.setText(getResources().getString(R.string.save));
        checkBox_save.setBackgroundColor(Color.RED);
    }
    //CICLOS ACTIVITY
    @Override
    public void onStart() {
        super.onStart();
        GoogleAnalytics.getInstance(this).reportActivityStart(this);
    }
    @Override
    protected void onRestart() {
        super.onRestart();
    }
    @Override
    public void onResume() {
        super.onResume();
        if (adView != null) {
            adView.resume();
        }
    }
    @Override
    public void onPause() {
        if (adView != null) {
            adView.pause();
        }
        super.onPause();
    }
    @Override
    public void onStop() {
        GoogleAnalytics.getInstance(this).reportActivityStop(this);
        super.onStop();
    }
    @Override
    public void onDestroy() {
        if (adView != null) {
            adView.destroy();
        }
        super.onDestroy();
    }
    //fin ciclos Activity

}

