package com.jesusrojo.miphoto.view;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;

import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.analytics.GoogleAnalytics;
import com.jesusrojo.miphoto.model.almacen.PhotosSQLite;
import com.jesusrojo.miphoto.model.almacen.IAlmacen;
import com.jesusrojo.miphoto.model.almacen.UsersSQLite;
import com.jesusrojo.miphoto.presenter.LoginTask;
import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;

public class LoginActivity extends AppCompatActivity
        implements LoginTask.ILoginTaskCallback {

	private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
    private static SharedPreferences mSharedPref;
    boolean pref_login_status;
    private SharedPreferences.Editor editor;

    private EditText ET_name, ET_password;
    private CheckBox checkBox_remember;
	private String name, password;

	private ProgressDialog progressDialog;
	public static boolean isTaskWorking;
	public static boolean isDevice;
    private AdView adView;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login_layout);
        this.mActivity = this;
        this.mContext = getApplicationContext();

        adView = (AdView)findViewById(R.id.adView);
        AdRequest adRequest = new AdRequest.Builder()
                .build();
        adView.loadAd(adRequest);

        //views
        ET_name = (EditText) findViewById(R.id.ET_name);
        ET_password = (EditText) findViewById(R.id.ET_password);
        checkBox_remember =(CheckBox) findViewById(R.id.checkBox_remember);

        //preferences
        mSharedPref = getSharedPreferences(Constants.PREFERENCES_DEFAULT, Context.MODE_PRIVATE);
        pref_login_status = mSharedPref.getBoolean("login_status", false);
        name = mSharedPref.getString("name", "");
        password = mSharedPref.getString("password", "");

        //check if we have a name in preferences to put in the EditText
        if (!TextUtils.isEmpty(name)) {
            ET_name.setText(name);
            ET_password.setText(password);
            checkBox_remember.setChecked(true);
            if(name.equals("Default")){
                ET_name.setText("");
                ET_password.setText("");
                checkBox_remember.setChecked(false);
            }
        } else {
            ET_name.setText("");
            ET_password.setText("");
            checkBox_remember.setChecked(false);
        }

        //CHECK BOX
        checkBox_remember.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    //get and keep data
                    name = ET_name.getText().toString();
                    password = ET_password.getText().toString();

                    editor = mSharedPref.edit();
                    editor.putString("name", name);
                    editor.putString("password", password);
                    editor.putBoolean("login_status", true);
                    editor.putBoolean("credencials_status", true);

                    editor.apply();
                    if (!TextUtils.isEmpty(name) && !TextUtils.isEmpty(password)) {
                        Utils.showToast(mContext, "Saved, name: " + name
                                                    + " pass: " + password);
                    }
                } else {
                    //UN CHECKED
                    name = mSharedPref.getString("name", "");
                    password = mSharedPref.getString("password", "");
                   //toast what we are going to delete
                    if (!TextUtils.isEmpty(name) && !TextUtils.isEmpty(password)) {
                        Utils.showToast(mContext, "Deleted, name: " + name
                                                        + " pass: " + password);
                    }
                    //delete and set null everything
                    ET_name.setText("");
                    ET_password.setText("");

                    editor = mSharedPref.edit();
                    editor.putString("name", "");
                    editor.putString("password", "");
                    editor.putBoolean("login_status", false);
                    editor.putBoolean("credencials_status", false);
                    editor.apply();
                }
            }
        });

        //keep states on  ProgressDialog
        if (savedInstanceState != null) {
            isTaskWorking = savedInstanceState.getBoolean("isTaskWorking");
        }
		progressDialog = new ProgressDialog(this);
	}//onCreate

    public void login(View v) {
        //get DATA from the form
        name = ET_name.getText().toString();
        password = ET_password.getText().toString();

        if (!TextUtils.isEmpty(name) || !TextUtils.isEmpty(password)) {

            LoginTask task = new LoginTask(mActivity, mContext,
                    progressDialog, LoginActivity.this);

            switch(v.getId()) {
                case R.id.btn_login_device:

                    task.empezarTask(name, password,"device");
                    isTaskWorking = true;
                    isDevice = true;
                    break;
                case R.id.btn_login_cloud:

                    task.empezarTask(name, password, "cloud");
                    isTaskWorking = true;
                    isDevice= false;
                    break;
            }//switch

        } else {
            Utils.showToastCustom(mContext, mActivity.getResources().getString( R.string.error_fill_the_form), "rojo", 0);
        }
    }
    @Override
    public void onFinishMyLoginTask(String result) {
        if ( result.equals(Constants.SUCCESS) ) {
            editor = mSharedPref.edit();
            editor.putBoolean("login_status", true);
            editor.putString("name", name);
            editor.putString("password", password);
            if(isDevice) {
                editor.putBoolean("login_device", true);
                editor.putString("table_name", name + "D_miPhoto");//== D device*****
            } else{
                editor.putBoolean("login_device", false);
                editor.putString("table_name", name + "C_miPhoto");//== C cloud*****
            }

            if (checkBox_remember.isChecked()) {
                editor.putBoolean("credencials_status", true);
            } else {
                editor.putBoolean("credencials_status", false);
            }
            //add changes to shared preferences
            editor.apply();

            Intent intent = new Intent(this, PhotosListActivity.class);
            startActivity(intent);
            finish();

        } else {
            editor = mSharedPref.edit();
            editor.putBoolean("login_status", false);
            editor.apply();
            Utils.showToastCustom(mContext, result, "rojo", 0);
        }
    }

    public void makeIntentRegisterActivity(View v) {
		startActivity(new Intent(this, RegisterActivity.class));
		finish();
	}
    public void makeIntentPasswordForgottenActivity(View v) {
        startActivity(new Intent(this, PasswordForgottenActivity.class));
        finish();
    }

    //GUARDAR ESTADOS
	@Override
	protected void onSaveInstanceState(Bundle outState) {
		super.onSaveInstanceState(outState);
		outState.putBoolean("isTaskWorking", isTaskWorking);
	}
	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
		super.onRestoreInstanceState(savedInstanceState);
		if (savedInstanceState.containsKey("isTaskWorking")) {
			if (savedInstanceState.getBoolean("isTaskWorking"))
				progressDialog.show();
		}
	}

    //CICLOS ACTIVITY
    @Override
    public void onStart() {
        super.onStart();
        GoogleAnalytics.getInstance(this).reportActivityStart(this);
    }
    @Override
    protected void onRestart() {
        super.onRestart();
    }
    @Override
    public void onResume() {
        super.onResume();
        if (adView != null) {
            adView.resume();
        }
    }
    @Override
    public void onPause() {
        if (adView != null) {
            adView.pause();
        }
        super.onPause();
    }
    @Override
    public void onStop() {
        GoogleAnalytics.getInstance(this).reportActivityStop(this);
        super.onStop();
    }
    @Override
    public void onDestroy() {
        if (adView != null) {
            adView.destroy();
        }
        super.onDestroy();
    }
    //fin ciclos Activity
/*

        if (pref_login_status) {
            //LOGUEADOS
            //ahora comprobamos si estamos en registro para maquina/device
            // D diferenciamos el nombre de la tabla,por si el mismo usuario se registra en Device o en Cloud
            if (login_device) {
                //DEVICE
                mName = name + "D";
                //comprobar si prefier no guardar credenciales
                if (!TextUtils.isEmpty(tempName)) {
                    mName = tempName + "D";
                }

            } else {
                //CLOUD
                //comprobar si tiene nombre registrado
                if (!TextUtils.isEmpty(name)) {
                    mName = name;
                } else {
                    mName = "Default";
                }

                //comprobar si prefier no guardar credenciales
                if (!TextUtils.isEmpty(tempName)) {
                    mName = tempName;
                }
            }
        } else {
            //NO LOGUEADOS
            mName = "Default";
        }
 */
}
