package com.jesusrojo.miphoto.view;


import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.analytics.GoogleAnalytics;
import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.presenter.RegisterTask;
import com.jesusrojo.miphoto.presenter.NewPasswordTask;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.ui.dialogFragment.PasswordForgottenDialog;

public class PasswordForgottenActivity extends AppCompatActivity
        implements NewPasswordTask.INewPasswordTaskCallback{

    private final String TAG = getClass().getSimpleName();
    private Activity mActivity;
    private Context mContext;
	public static SharedPreferences mSharedPref;

    private ProgressDialog progressDialog;
	public static boolean isTaskWorking;

	private EditText ET_mail;
    private AdView adView;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.password_forgotten);
        this.mActivity = this;
        this.mContext = getApplicationContext();

        adView = (AdView)findViewById(R.id.adView);
        AdRequest adRequest = new AdRequest.Builder()
                .build();
        adView.loadAd(adRequest);

        mSharedPref = getSharedPreferences(Constants.PREFERENCES_DEFAULT, Context.MODE_PRIVATE);

		ET_mail = (EditText) findViewById(R.id.ET_mail);

        //keep states on  ProgressDialog
        if (savedInstanceState != null) {
            isTaskWorking = savedInstanceState.getBoolean("isTaskWorking");
        }
        progressDialog = new ProgressDialog(mActivity);

    }//onCreate

    public final static boolean isValidEmail(CharSequence target) {
        return !TextUtils.isEmpty(target)
                && android.util.Patterns.EMAIL_ADDRESS.matcher(target).matches();
    }
    public void sendNewPassword(View v) {
        Utils.hideSoftKeyboard(PasswordForgottenActivity.this);
        String  mail = ET_mail.getText().toString();
        //VALIDACIONES
        if (TextUtils.isEmpty(mail)) {
              Utils.showToast(mContext, "Error: Email missing");
              return;
        }
        if (!isValidEmail(mail)) {
               Utils.showToast(mContext, "Error: Email no valid");
               return;
        }
        NewPasswordTask task = new NewPasswordTask(mActivity, mContext,
                progressDialog, PasswordForgottenActivity.this);
        switch(v.getId()) {
            case R.id.btn_new_password_device:

                task.empezarTask( mail, "device" );
                isTaskWorking = true;
                break;
            case R.id.btn_new_password_cloud:
                if(DatosConexionActivity.checkDatosConexion(mSharedPref)) {

                    task.empezarTask( mail, "cloud" );
                    isTaskWorking = true;

                } else {
                    Utils.showToastCustom(mActivity, mActivity.getResources().getString(R.string.no_hosting_data_conexion), "rojo", 0);
                }
                break;
        }//switch


    }

    @Override
    public void onFinishMyNewPasswordTask(String[] result) {
        TextView tv = (TextView) findViewById(R.id.tv_show_password);

        if(result != null ) {
          //  String texto = "Name: " +result[0] +"\nPassword: "+ result[1];
            String texto =  result[1];
            tv.setText(texto);
        } else {
            tv.setText("Error, email not registered");

        }
    }

    public void sendNewPasswordFAKE() {
        Utils.hideSoftKeyboard(PasswordForgottenActivity.this);

        if(DatosConexionActivity.checkDatosConexion(mSharedPref)) {
           String  mail = ET_mail.getText().toString();
            //VALIDACIONES
            if (TextUtils.isEmpty(mail)) {
              //  Utils.showToast(mContext, "Error: Email missing");
              //  return;
            }
            if (!isValidEmail(mail)) {
             //   Utils.showToast(mContext, "Error: Email no valid");
             //   return;
            }

            String title =getResources().getString(R.string.password_forgotten);
            String message = getResources().getString(R.string.register_again);

            DialogFragment newFragment = PasswordForgottenDialog.newInstance(
                    title, message);
            newFragment.show(getSupportFragmentManager(), "dialog");
        } else {
            Utils.showToastCustom(mActivity,
                    mActivity.getResources().getString(R.string.no_hosting_data_conexion), "rojo",0);
         }
	}

    //GUARDAR ESTADOS
    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putBoolean("isTaskWorking", isTaskWorking);
    }
    @Override
    protected void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        if (savedInstanceState.containsKey("isTaskWorking")) {
            isTaskWorking = savedInstanceState.getBoolean("isTaskWorking");
            if ( isTaskWorking ) {
                progressDialog.show();
            }
        }
    }
    //CICLOS ACTIVITY
    @Override
    public void onStart() {
        super.onStart();
        GoogleAnalytics.getInstance(this).reportActivityStart(this);
    }
    @Override
    protected void onRestart() {
        super.onRestart();
    }
    @Override
    public void onResume() {
        super.onResume();
        if (adView != null) {
            adView.resume();
        }
    }
    @Override
    public void onPause() {
        if (adView != null) {
            adView.pause();
        }
        super.onPause();
    }
    @Override
    public void onStop() {
        GoogleAnalytics.getInstance(this).reportActivityStop(this);
        super.onStop();
    }
    @Override
    public void onDestroy() {
        if (adView != null) {
            adView.destroy();
        }
        super.onDestroy();
    }
    //fin ciclos Activity

}
