package com.jesusrojo.miphoto.view;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;

import android.support.annotation.NonNull;
import android.support.v4.app.DialogFragment;
import android.support.v4.app.FragmentActivity;
import android.support.v4.content.LocalBroadcastManager;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;

import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.analytics.GoogleAnalytics;
import com.google.android.gms.analytics.Tracker;
import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.model.pojo.Photo;
import com.jesusrojo.miphoto.presenter.DeletePojoTask;
import com.jesusrojo.miphoto.presenter.ITaskCallback;
import com.jesusrojo.miphoto.presenter.SavePojoTask;
import com.jesusrojo.miphoto.presenter.UpdatePhotoTask;
import com.jesusrojo.miphoto.presenter.services.CopyBinaryIntentService;
import com.jesusrojo.miphoto.presenter.services.DeleteBinaryIntentService;
import com.jesusrojo.miphoto.utils.Constants;
import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.utils.UtilsFile;
import com.jesusrojo.miphoto.view.ui.dialogFragment.DeleteDialog;
import com.jesusrojo.miphoto.view.ui.dialogFragment.CloseSaveEditDialog;
import com.jesusrojo.miphoto.view.ui.dialogFragment.IDialogListener;

import java.io.File;
import java.util.List;

public class PhotoSaveEditActivity extends FragmentActivity
                 implements LocationListener, ITaskCallback, IDialogListener {

    private final String TAG = getClass().getSimpleName();
    private static Activity mActivity;
    private static Context mContext;
    private SharedPreferences mSharedPref;
    private AdView adView;

    private ImageView IVPhoto;
    private TextView TVimageUri,TV_info_conexion_gps;
    private TextView TV_info_conexion_net;
    private EditText ET_comentario, ET_latitud, ET_longitud;
    private Uri mImageUri = null;
    //jobindicate where do we come from
    //job values are  job_save, job_copy, job_edit
    private String job;
    private String path;
    private Photo mPhoto;

    //POSICION
    private LocationManager mLocationManager;
    private Location mLocation;
    public double mLatitud = 0;//inicializadas
    public double mLongitud = 0;
    private static final long DOS_MINUTOS= 2 * 60 * 1000;
    private static final long TIEMPO_MIN_GPS = 2 * 60 * 1000 ;
    private static final long TIEMPO_MIN_NET =     60 * 1000 ;
    private static final long DISTANCIA_MIN = 5 ; // 5 metros

    private CopyBinaryResultReceiver mCopyBinaryResultReceiver;
    private DeleteBinaryResultReceiver mDeleteBinaryResultReceiver;
    private static final int REQUEST_MAP_EDIT = 1;
    private boolean isBackFromMapEdit = false;
    private String[] mSelectArg = new String[1];

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.photo_save_edit_layout);
        Utils.showLog(TAG, "onCreate");
        mActivity = this;
        mContext = getApplicationContext();

        adView = (AdView)findViewById(R.id.adView);
        AdRequest adRequest = new AdRequest.Builder()
                .build();
        adView.loadAd(adRequest);

        //preferences
        mSharedPref = getSharedPreferences(Constants.PREFERENCES_DEFAULT, Context.MODE_PRIVATE);

        //views
        TVimageUri = (TextView) findViewById(R.id.TVimageUri);
        TV_info_conexion_gps = (TextView) findViewById(R.id.TV_info_conexion_gps);
        TV_info_conexion_net = (TextView) findViewById(R.id.TV_info_conexion_net);
        IVPhoto = (ImageView) findViewById(R.id.IVPhoto);
        ET_comentario = (EditText) findViewById(R.id.ET_comentario);
        ET_latitud = (EditText) findViewById(R.id.ET_latitud);
        ET_longitud = (EditText) findViewById(R.id.ET_longitud);

        //GET INTENT
        Bundle extras = getIntent().getExtras();
        job = extras.getString("job");
        path = extras.getString("path");
        if (!TextUtils.isEmpty(path)){
           mImageUri =Uri.parse(path);
           mSelectArg[0] =  path ;
        }
        pintarData(mImageUri);

        comprobarGeoposicion(mContext);

        // Receiver for the notification.
        mCopyBinaryResultReceiver = new CopyBinaryResultReceiver();
        mDeleteBinaryResultReceiver = new DeleteBinaryResultReceiver();
    }//onCreate
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if ( resultCode == Activity.RESULT_OK
                && requestCode == REQUEST_MAP_EDIT) {
            if (data != null) {
                String asd = data.getExtras().getString("path");
                double latitud = data.getExtras().getDouble("latitud");
                double longitud = data.getExtras().getDouble("longitud");

                if(mLatitud != 0 && mLongitud != 0){
                    ET_latitud.setText(String.valueOf(latitud));
                    ET_longitud.setText(String.valueOf(longitud));
                    isBackFromMapEdit = true;
                }
                Utils.showToastCustom(mContext, mContext.getResources().getString(R.string.do_not_forget_save_changes), "verde", 0);
            }
        }
    }

    private Photo createPhoto(File file) {
        Photo photo= new Photo();
        photo.setId(0);
        //name
        String name = mSharedPref.getString("name", "");
        if (!TextUtils.isEmpty(mSharedPref.getString("name", ""))) {
            photo.setOwner(name);
        } else {
            photo.setOwner("");
        }
        //path
        if(job.equals("job_save")) {
            photo.setPath(String.valueOf(mImageUri));
        }
        if(job.equals("job_copy")) {
            photo.setPath(String.valueOf(mImageUri));
            //tiene algo asi
            //lo almacenamos temporaneamente aqui en memoria
            //content://com.android.providers.media.documents/document/image%3A3516

            //  "job_copy"   para cuando volvemos de la copia
            // poner nuestra path en la SQLite y guardarla
            if(file != null) {
                photo.setPath("file://"+file.getPath());
            }
        }
        if(job.equals("job_edit")) {
            photo.setPath(String.valueOf(mImageUri));
        }
        //pathFilter
        photo.setPathFilter("");
        photo.setLatitude(Double.parseDouble(getLatitudFromET()));
        photo.setLongitude(Double.parseDouble(getLongitudFromET()));
        photo.setComment(getComentarioFromET());
        photo.setStatus(0);
        photo.setTime(System.currentTimeMillis());
        return photo;
    }
    //SAVE
    private void empezarSavePojoTask(Activity a, Context c,Photo mPhoto) {

        SavePojoTask task = new SavePojoTask(a, c,PhotoSaveEditActivity.this);
        task.execute(mPhoto);
    }
    public void save(View view) {
        Utils.hideSoftKeyboard(PhotoSaveEditActivity.this);
        if(mImageUri != null) {

            mPhoto  = createPhoto(null);

            if(job.equals("job_save")){
                //save pojo  data con AsynTask
                empezarSavePojoTask(mActivity, mContext, mPhoto);
            }
            if(job.equals("job_copy")){
                //copiar la data binaria en un folder de  miPhoto
                copyBinaryWithIntentService(Uri.parse(mPhoto.getPath()));
            }
            if(job.equals("job_edit")){
                //update el pojo data de la foto solo
                UpdatePhotoTask updatePhotoTask = new UpdatePhotoTask(mActivity,mContext);
                updatePhotoTask.execute(mPhoto);
            }
        } else {
            Utils.showToast(mContext, getResources().getString(R.string.error_no_path));
        }
    }
    public void lanzarMapaEditGeopuntoActivity(View view) {
        Intent intent = new Intent(this, MapEditActivity.class);
        startActivityForResult(intent, REQUEST_MAP_EDIT);
    }
    public void delete(View view) {
        DialogFragment newFragment =
                DeleteDialog.newInstance(job);
        newFragment.show(getSupportFragmentManager(), "dialog");
    }
    public void close(View view) {
        CloseSaveEditDialog newFragment =
                CloseSaveEditDialog.newInstance(job);
        newFragment.show(getSupportFragmentManager(), "dialog");
    }
    //SERVICE COPY
    public void copyBinaryWithIntentService(Uri uri){
        // Sends an Intent command to the CopyBinaryIntentService.
        startService(CopyBinaryIntentService.makeIntent(getApplicationContext(), uri));
    }
    private class CopyBinaryResultReceiver extends BroadcastReceiver {
        private final String TAG = getClass().getSimpleName();
        @Override
        public void onReceive(Context context,
                              Intent intent) {
            String respuesta = intent.getStringExtra("respuesta");
            String path = intent.getStringExtra("path");
            if (respuesta.equals(Constants.SUCCESS_COPIED)) {
                //creamos foto con el nuevo file y guardamos pojo en SQLite
                mPhoto = createPhoto(new File(path));
                empezarSavePojoTask(mActivity, mContext, mPhoto);
            } else {
                Utils.showToast(context, respuesta);
            }
        }
    }
    private void registerReceiverCopyBinary() {
        // Create an Intent filter that handles Intents from the IntentService.
        IntentFilter intentFilter =
                new IntentFilter(CopyBinaryIntentService.ACTION_COPY_RESPONSE);
        intentFilter.addCategory(Intent.CATEGORY_DEFAULT);
        // Register the BroadcastReceiver.
        LocalBroadcastManager.getInstance(this)
                .registerReceiver(mCopyBinaryResultReceiver, intentFilter);
    }
    //method from DeleteDialogFragment
    @Override
    public void eleccionDeleteBinaryIntentService(DialogFragment dialog) {
        deleteBinaryWithIntentService(Uri.parse(path));
    }

    //DELETE
    private void deleteBinaryWithIntentService(Uri uri) {
        startService(DeleteBinaryIntentService.makeIntent(getApplicationContext(), uri,2));
    }
    private class DeleteBinaryResultReceiver extends BroadcastReceiver {
        @Override
        public void onReceive(Context context,
                              Intent intent) {
            String respuesta = intent.getStringExtra("respuesta");

            if(respuesta.equals(Constants.SUCCESS_DELETED)) {

                empezarDeletePojoTask();
            } else  {
                Utils.showToast(context,getResources().getString(R.string.error_not_deleted));
            }
        }
    }
    public void empezarDeletePojoTask() {
        DeletePojoTask task =
                new DeletePojoTask(mActivity, mContext, (ITaskCallback) mActivity);
        task.execute(mSelectArg);
    }

    @Override
    public void onFinishDeletePojoTask(String result) {
        startActivity(new Intent(mContext, PhotosListActivity.class));
        finish();
    }
    @Override
    public void onFinishUpdatePathFilterTask(String result) {}
    @Override
    public void onFinishSavePojoNubeTask(String result, Photo photo) {}
    @Override
    public void onFinishGetListTask(List<Photo> result) {}

    private void registerReceiverDeleteBinary() {
        // Create an Intent filter that handles Intents from the IntentService.
        IntentFilter intentFilter =
                new IntentFilter(DeleteBinaryIntentService.ACTION_DELETE_BYNARY_RESPONSE);
        intentFilter.addCategory(Intent.CATEGORY_DEFAULT);
        // Register the BroadcastReceiver.
        LocalBroadcastManager.getInstance(this).registerReceiver(mDeleteBinaryResultReceiver,
                intentFilter);
    }

    private void pintarData(Uri uri) {
        Utils.showLog(TAG, "uri: "+ uri.toString());
        TVimageUri.setText(String.valueOf(uri));
        if(uri != null) {
            if(job.equals("job_save") || job.equals("job_copy")) {
                IVPhoto.setImageBitmap(
                        //  UtilsFile.getThumbnail(photo.getPath()) );
                        UtilsFile.reduceBitmap(
                                mActivity, String.valueOf(uri), 500, 500));
                IVPhoto.setScaleType(ImageView.ScaleType.FIT_CENTER);
            } else if(job.equals("job_edit")) {
                Photo photo = PhotosListActivity.mIAlmacen.getPhoto(mContext, path);

                IVPhoto.setImageBitmap(
                        //  UtilsFile.getThumbnail(photo.getPath()) );
                        UtilsFile.reduceBitmap(
                                mActivity, String.valueOf(uri), 500, 500));
                IVPhoto.setScaleType(ImageView.ScaleType.FIT_CENTER);
                ET_comentario.setText(photo.getComment());
                ET_latitud.setText(String.valueOf(photo.getLatitude()));
                ET_latitud.setText(String.valueOf(photo.getLongitude()));
            } else {
                //IVPhoto.setImageBitmap(null);
                if (  Build.VERSION.SDK_INT < 21 ) {
                    IVPhoto.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_menu_report_image));
                } else {
                    IVPhoto.setImageDrawable(getResources().getDrawable(android.R.drawable.ic_menu_report_image, null));
                }
            }
        }//null
    }
    private void comprobarGeoposicion(Context context) {
        //LOCATION
        mLocationManager = (LocationManager) context.getSystemService(LOCATION_SERVICE);
        //GPS
        if(mLocationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)){
            Location location = mLocationManager.getLastKnownLocation(
                    LocationManager.GPS_PROVIDER);
            if(location != null){
                setMyLocation(location);
                //  Utils.showToast(this, "GPS actual location: " + mLatitud + ", " + mLongitud);
            } else {
                // Utils.showToast(this, "GPS try to find location...");
                TV_info_conexion_gps.setText(getResources().getString(R.string.GPS_try_find_location));
            }
            actualizaMejorLocaliz(location);
        } else {
            //   Utils.showToast(this, "GPS in not available");
            TV_info_conexion_gps.setText(getResources().getString(R.string.GPS_is_not_available));
        }
        //NET
        if(mLocationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER)){

            Location location = mLocationManager.getLastKnownLocation(
                    LocationManager.NETWORK_PROVIDER);
            if(location != null){
                setMyLocation(location);
                // Utils.showToast(this, "NET actual location: " + mLatitud + ", " + mLongitud);
            } else {
                // Utils.showToast(this, "NET try to find location...");
                TV_info_conexion_net.setText(getResources().getString(R.string.NET_try_find_location));

            }
            actualizaMejorLocaliz(location);
        } else {
            //  Utils.showToast(this, "NET in not available");
            TV_info_conexion_net.setText(getResources().getString(R.string.NET_is_not_available));
        }
        //end location
    }
    private void setMyLocation(Location location) {
        mLatitud = location.getLatitude();
        mLongitud = location.getLongitude();
        //mActualLatLng =  new LatLng(mLatitud,mLongitud);

        String latLong = "Actual position: Lat: " + mLatitud +", Lng: " + mLongitud;
        TV_info_conexion_net.setText(latLong);
        // String gpslatLong = "GPS actual position: Lat: " + mLatitud +", Lng: " + mLongitud;
        //  String netlatLong = "NET actual position: Lat: " + mLatitud +", Lng: " + mLongitud;
        // TV_info_conexion_gps.setText(gpslatLong);
        // TV_info_conexion_net.setText(netlatLong);
        if(!isBackFromMapEdit) {
            ET_latitud.setText(String.valueOf(mLatitud));
            ET_longitud.setText(String.valueOf(mLongitud));
        }
    }
    private void activarLocationManager() {
        if(mLocationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)){
            mLocationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
                    TIEMPO_MIN_GPS, DISTANCIA_MIN, this);
        }
        if(mLocationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER)){
            mLocationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER,
                    TIEMPO_MIN_NET, DISTANCIA_MIN, this);
        }
    }
    private void actualizaMejorLocaliz(Location location) {
        if (location != null) {
            if (location != null && mLocation == null
                    ||  location.getAccuracy() < 2 * mLocation.getAccuracy()
                    || location.getTime() - mLocation.getTime() > DOS_MINUTOS
                    ) {
                mLocation = location;
                setMyLocation(location);
                // Utils.showToast(this, "Actualizado: lat: " + mLatitud + ", long: " + mLongitud);
            }
        }
    }
    // METODOS DE LA INTERFAZ  LocationListener
    @Override
    public void onLocationChanged(Location location) {
        if (location != null) {
            mLocationManager.removeUpdates(this);
            actualizaMejorLocaliz(location);
        }
    }
    @Override
    public void onProviderEnabled(String proveedor) {
        if (proveedor != null) {
            activarLocationManager();
        }
    }
    @Override
    public void onProviderDisabled(String proveedor) {
        if (proveedor != null) {
            activarLocationManager();
        }
    }
    @Override
    public void onStatusChanged(String proveedor, int estado,
                                Bundle extras) {
        activarLocationManager();
    }
    //end Métodos de la interfaz LocationListener

    //SALVAR ESTADOS
    @Override
    protected void onSaveInstanceState(@NonNull Bundle guardarEstado) {
        super.onSaveInstanceState(guardarEstado);
        guardarEstado.putDouble("param_latitud", mLatitud);
        guardarEstado.putDouble("param_longitud", mLongitud);
        guardarEstado.putString("param_path", String.valueOf(mImageUri));
    }
    @Override
    protected void onRestoreInstanceState(@NonNull Bundle recEstado) {
        super.onRestoreInstanceState(recEstado);
        mLatitud = recEstado.getDouble("param_latitud");
        mLongitud = recEstado.getDouble("param_longitud");
        mImageUri = Uri.parse(recEstado.getString("param_path"));
    }
    //end of salvar estados

    private String getComentarioFromET() {
        String comment = ET_comentario.getText().toString();
        if (TextUtils.isEmpty(comment)){
            return "";
        } else {
            return comment;
        }
    }
    private String getLatitudFromET() {
        String text = ET_latitud.getText().toString();
        if (TextUtils.isEmpty(text)){
            return "0";
        }
        return text;
    }
    private String getLongitudFromET() {
        String text = ET_longitud.getText().toString();
        if (TextUtils.isEmpty(text)){
            return "0";
        } else {
            return text;
        }
    }
    private void lanzarIntentListActivity() {
        startActivity(new Intent(PhotoSaveEditActivity.this, PhotosListActivity.class));
        finish();
    }
    /****** CICLOS ACTIVITY ******/
    @Override
    public void onStart() {
        super.onStart();
        GoogleAnalytics.getInstance(this).reportActivityStart(this);
    }
    @Override
    protected void onRestart() {
        super.onRestart();
        Utils.showLog(TAG, "onRestart()");

    }
    @Override
    protected void onResume() {
        super.onResume();
        Utils.showLog(TAG, "onResume()");

        activarLocationManager();
        registerReceiverCopyBinary();
        registerReceiverDeleteBinary();
        if (adView != null) {
            adView.resume();
        }
    }
    @Override
    protected void onPause() {
        super.onPause();
        mLocationManager.removeUpdates(this);
        // Unregister BroadcastReceiver.
        LocalBroadcastManager.getInstance(this)
                .unregisterReceiver(mCopyBinaryResultReceiver);
        LocalBroadcastManager.getInstance(this)
                .unregisterReceiver(mDeleteBinaryResultReceiver);
        if (adView != null) {
            adView.pause();
        }
    }

    @Override
    public void onStop() {
        GoogleAnalytics.getInstance(this).reportActivityStop(this);
        super.onStop();
    }
    @Override
    public void onDestroy() {
        if (adView != null) {
            adView.destroy();
        }
        super.onDestroy();
    }
    //fin ciclos Activity
    /******
    @Override
    public void onBackPressed() {
        close(null);
    }
    ******/
}
