package com.jesusrojo.miphoto.view.ui.dialogFragment;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import com.jesusrojo.miphoto.R;

import com.jesusrojo.miphoto.utils.Utils;
import com.jesusrojo.miphoto.view.PhotosListActivity;

public class CloseSaveEditDialog extends DialogFragment {

    private static final String TAG = CloseSaveEditDialog.class.getSimpleName();

    // Use this instance of the interface to deliver action events
    IDialogListener mListener;

    public CloseSaveEditDialog() {
    }
    public static CloseSaveEditDialog newInstance(String job) {
        CloseSaveEditDialog frag = new CloseSaveEditDialog();
        Bundle args = new Bundle();
        args.putString("job", job);
        frag.setArguments(args);
        return frag;
    }
    // Override the Fragment.onAttach() method to instantiate the IDialogListener
    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        // Verify that the host activity implements the callback interface
        try {
            // Instantiate the NoticeDialogListener so we can send events to the host
            mListener = (IDialogListener) activity;
        } catch (ClassCastException e) {
            // The activity doesn't implement the interface, throw exception
            throw new ClassCastException(activity.toString()
                    + " must implement IDialogListener");
        }
    }
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {

        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());

        String title = getResources().getString(R.string.close);
        builder.setTitle(title);

        String job= getArguments().getString("job");
        Utils.showLog(TAG, "job " + job);

        String message = "";
        if (job != null) {
            if (job.equals("job_save")) {
                message = getResources().getString(R.string.photo_will_be_deleted_from_app_folder_still_in_camera_folder);
                builder.setPositiveButton(R.string.close_delete, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {

                        //borramos la imagen que ya estaba guardada en nuestro folder
                        mListener.eleccionDeleteBinaryIntentService(CloseSaveEditDialog.this);
                        //cancel this dialog
                        CloseSaveEditDialog.this.getDialog().cancel();
                    }
                });
            }
            if (job.equals("job_copy") || job.equals("job_edit")) {
                if (job.equals("job_copy")) {
                    message = getResources().getString(R.string.you_will_exit_without_saving_photo);
                }
                if (job.equals("job_edit")) {
                    message = getResources().getString(R.string.you_will_exit_without_saving_changes);
                }
                builder.setPositiveButton(R.string.close, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        //close and go to ListActivity
                        getActivity().startActivity(new Intent(getActivity(), PhotosListActivity.class));
                        getActivity().finish();

                        //cancel this dialog
                        CloseSaveEditDialog.this.getDialog().cancel();
                    }
                });
            }
        }

        builder.setMessage(message);

        builder.setNeutralButton(R.string.cancel, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface arg0, int arg1) {
                //cancel this dialog
                CloseSaveEditDialog.this.getDialog().cancel();
            }
        });

        return builder.create();
    }
}