package com.jesusrojo.miphoto.view.ui.dialogFragment;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import com.jesusrojo.miphoto.R;
import com.jesusrojo.miphoto.utils.Utils;

public class DeleteDialog extends DialogFragment {
    private final String TAG = getClass().getSimpleName();

    // Use this instance of the interface to deliver action events
    IDialogListener mListener;

    //// Empty constructor required for DialogFragment
    public DeleteDialog() {
    }
    public static DeleteDialog newInstance(String job) {
        DeleteDialog frag = new DeleteDialog();

        Bundle args = new Bundle();
        args.putString("job", job);
        frag.setArguments(args);
        return frag;
    }
    // Override the Fragment.onAttach() method to instantiate the IDialogListener
    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        // Verify that the host activity implements the callback interface
        try {
            // Instantiate the NoticeDialogListener so we can send events to the host
            mListener = (IDialogListener) activity;
        } catch (ClassCastException e) {
            // The activity doesn't implement the interface, throw exception
            throw new ClassCastException(activity.toString()
                    + " must implement IDialogListener");
        }
    }

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {

        String title = getResources().getString(R.string.delete);
        String message = "";
        String job= getArguments().getString("job");
        String textInButton = "";

        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
        builder.setTitle(title);

        //message and  text in bottons depends our job
        if (job != null) {
            //SafeEditActiviyy
            if (job.equals("job_edit") || job.equals("job_save") ) {
                message = getResources().getString(R.string.are_you_sure);
                textInButton = getResources().getString(R.string.delete_and_close);
            }
            //SafeEditActiviyy
            if (job.equals("job_copy")) {
                message = getResources().getString(R.string.not_possible_delete_from_gallery);
                // no button
            }
            //from ListActivity
            if (job.equals("job_delete")) {
                message = getResources().getString(R.string.are_you_sure);
                textInButton = getResources().getString(R.string.delete);
            }

            if (job.equals("job_save")
                    || job.equals("job_edit")
                    || job.equals("job_delete")) {
                message = getResources().getString(R.string.are_you_sure);

                builder.setPositiveButton(textInButton, new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface arg0, int arg1) {
                        mListener.eleccionDeleteBinaryIntentService(DeleteDialog.this);
                        //cancel this dialog
                        DeleteDialog.this.getDialog().cancel();
                    }
                });
            }

        }
        builder.setMessage(message);

        //cancel button
        builder.setNeutralButton(R.string.cancel, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface arg0, int arg1) {
                //cancel this dialog
                DeleteDialog.this.getDialog().cancel();
            }
        });

        return builder.create();
    }
}
