package com.jesusrojo.miphoto.view.ui.dialogFragment;


import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;

import com.jesusrojo.miphoto.R;

import com.jesusrojo.miphoto.view.RegisterActivity;

public class PasswordForgottenDialog extends DialogFragment {

    private static final String TAG = PasswordForgottenDialog.class.getSimpleName();
    public PasswordForgottenDialog() {
    }
    public static PasswordForgottenDialog newInstance( String title,String message) {
        PasswordForgottenDialog frag = new PasswordForgottenDialog();
        Bundle args = new Bundle();
        args.putString("title", title);
        args.putString("message", message);
        frag.setArguments(args);
        return frag;
    }
    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {

        AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());

        builder.setTitle(getArguments().getString("title"));
        builder.setMessage(getArguments().getString("message"));

        builder.setPositiveButton(R.string.register, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface arg0, int arg1) {
                //close and go to ListActivity
                getActivity().startActivity(new Intent(getActivity(), RegisterActivity.class));
                getActivity().finish();
                //cancel this dialog
                PasswordForgottenDialog.this.getDialog().cancel();
            }
        });


        builder.setNeutralButton(R.string.cancel, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface arg0, int arg1) {
                //cancel this dialog
                PasswordForgottenDialog.this.getDialog().cancel();
            }
        });

        return builder.create();
    }
}